#include <Date.au3>
#include <Process.au3>

;User Variables
If FileExists("7dServerUtility.ini") Then
   Local $GamePort = IniRead("7dServerUtility.ini", "GameServerPort", "GamePort", "25000")
   Local $ConfigFile = IniRead("7dServerUtility.ini", "GameConfigFile", "ConfigFile", "serverconfig.xml")
   Local $UseRemoteRestart = IniRead("7dServerUtility.ini", "Use_Remote_Restart?yes/no", "UseRemoteRestart", "no")
   Local $g_IP = IniRead("7dServerUtility.ini", "IP_To_Listen_On", "ListenIP", "127.0.0.1")
   Local $g_Port = IniRead("7dServerUtility.ini", "Port_To_Listen_On", "ListenPort", "57539")
   Local $RestartCode = IniRead("7dServerUtility.ini", "Remote_Restart_Password", "RestartCode", "FVtb2DXgp8SYwj7J")
   Local $RestartDaily= IniRead("7dServerUtility.ini", "Restart_Daily?yes/no", "RestartDaily", "no")
   Local $HotHour = IniRead("7dServerUtility.ini", "Restart_Time_Hour?00-23", "HotHour", "00")
   Local $HotMin = IniRead("7dServerUtility.ini", "Restart_Time_Minute?00-59", "HotMin", "01")
   Local $ExMem = IniRead("7dServerUtility.ini", "Excessive_Memory_Amount", "ExMem", "2000000000")
   Local $ExMemRestart = IniRead("7dServerUtility.ini", "Restart_On_Excessive_Mem_Use?yes/no", "ExMemRestart", "no")
Else
   IniWrite("7dServerUtility.ini", "GameServerPort", "GamePort", "25000")
   IniWrite("7dServerUtility.ini", "GameConfigFile", "ConfigFile", "serverconfig.xml")
   IniWrite("7dServerUtility.ini", "Use_Remote_Restart?yes/no", "UseRemoteRestart", "no")
   IniWrite("7dServerUtility.ini", "IP_To_Listen_On", "ListenIP", "127.0.0.1")
   IniWrite("7dServerUtility.ini", "Port_To_Listen_On", "ListenPort", "57539")
   IniWrite("7dServerUtility.ini", "Remote_Restart_Password", "RestartCode", "FVtb2DXgp8SYwj7J")
   IniWrite("7dServerUtility.ini", "Restart_Daily?yes/no", "RestartDaily", "no")
   IniWrite("7dServerUtility.ini", "Restart_Time_Hour?00-23", "HotHour", "00")
   IniWrite("7dServerUtility.ini", "Restart_Time_Minute?00-59", "HotMin", "01")
   IniWrite("7dServerUtility.ini", "Excessive_Memory_Amount", "ExMem", "2000000000")
   IniWrite("7dServerUtility.ini", "Restart_On_Excessive_Mem_Use?yes/no", "ExMemRestart", "no")
   MsgBox(4096, "Default INI File Made", "Please Modify Default Values and Restart Script")
   Exit
EndIf

OnAutoItExitRegister("CloseServer")

Func CloseServer()
   If FileExists(@ScriptDir & "\puttytel.exe") Then
	  $PuttyPort = $GamePort+3
	  Run(@ScriptDir & "\puttytel.exe -P "& $PuttyPort & " "& $g_IP)
	  WinWait($g_IP &" - PuTTYtel","")
	  Local $CrashCheck = WinWait("PuTTYtel Fatal Error","",5)
	  If $CrashCheck = 0 Then
		 ControlSend($g_IP &" - PuTTYtel", "", "", "{enter}")
		 ControlSend($g_IP &" - PuTTYtel", "", "", "shutdown{enter}")
		 WinWait("PuTTYtel Fatal Error","",10)
		 Local $PID = ProcessExists("puttytel.exe")
		 If $PID Then
			ProcessClose($PID)
		 EndIf
	  Else 
		 Local $PID = ProcessExists("puttytel.exe")
		 Local $PID2 = ProcessExists("7DaysToDie.exe")
			If $PID Then
			   ProcessClose($PID)
			EndIf
			If $PID2 Then
			   ProcessClose($PID2)
			EndIf
	  EndIf
   Else
      Local $PID = ProcessExists("7DaysToDie.exe")
	  If $PID Then
		 ProcessClose($PID)
	  EndIf
   EndIf
EndFunc

Func _TCP_Server_ClientIP($hSocket)
   Local $pSocketAddress, $aReturn
   $pSocketAddress = DllStructCreate("short;ushort;uint;char[8]")
   $aReturn = DllCall("ws2_32.dll", "int", "getpeername", "int", $hSocket, "ptr", DllStructGetPtr($pSocketAddress), "int*", DllStructGetSize($pSocketAddress))
   If @error Or $aReturn[0] <> 0 Then Return $hSocket
	  $aReturn = DllCall("ws2_32.dll", "str", "inet_ntoa", "int", DllStructGetData($pSocketAddress, 3))
   If @error Then Return $hSocket
	  $pSocketAddress = 0
   Return $aReturn[0] 
EndFunc ;==>_TCP_Server_ClientIP

If $UseRemoteRestart = "yes" Then
; Start The TCP Services
TCPStartup()
Local $MainSocket = TCPListen($g_IP, $g_Port, 100)
If $MainSocket = -1 Then Exit
EndIf

while True
	if WinExists("Oops!") Then
		ControlSend("Oops!", "", "", "{enter}")
		Sleep (10000)
	EndIf
If $UseRemoteRestart = "yes" Then
Local $ConnectedSocket = TCPAccept($MainSocket)
If $ConnectedSocket >= 0 Then
;TrayTip("Connected","Someone connected to server.",3)
$Count = 0
While $Count < 30
$RECV = TCPRecv($ConnectedSocket,512)
   If $RECV = $RestartCode Then
   Local $PID = ProcessExists("7DaysToDie.exe") ; Will return the PID or 0 if the process isn't found.   
	  If $PID Then
		 $IP = _TCP_Server_ClientIP($ConnectedSocket)
		 Local $MEM = ProcessGetStats($PID, 0)
		 FileWriteLine(@ScriptDir & "\7dServerUtility_RestartLog.txt", @MON &"-"& @MDAY &"-"& @YEAR &" "& @HOUR &":"& @MIN &" --Work Memory:"& $MEM[0] & _
		 " --Peak Memory:"& $MEM[1] &" Restart Requested by Remote Host: "& $IP)
		 ;ProcessClose($PID)
		 CloseServer()
		 Sleep (10000)
		 ExitLoop
	  EndIf
   EndIf
$Count += 1
Sleep (1000)
WEnd
If $ConnectedSocket <> -1 Then TCPCloseSocket($ConnectedSocket)
EndIf
EndIf

Local $PID = ProcessExists("7DaysToDie.exe")
If $PID = 0 Then
   Run(@ScriptDir & "\7DaysToDie.exe -quit -batchmode -nographics -configfile="& $ConfigFile &" -dedicated")
   Sleep (70000)
Else 
   Local $MEM = ProcessGetStats($PID, 0)
   If $MEM[0] > $ExMem And $ExMemRestart = "no" Then
	  FileWriteLine(@ScriptDir & "\7dServerUtility_ExcessiveMemoryLog.txt", @MON &"-"& @MDAY &"-"& @YEAR &" "& @HOUR &":"& @MIN &" --Work Memory:"& $MEM[0] & _
        " --Peak Memory:"& $MEM[1])
	  Sleep (10000)
   ElseIf $MEM[0] > $ExMem And $ExMemRestart = "yes" Then
	  FileWriteLine(@ScriptDir & "\7dServerUtility_RestartLog.txt", @MON &"-"& @MDAY &"-"& @YEAR &" "& @HOUR &":"& @MIN &" --Work Memory:"& $MEM[0] & _
	  " --Peak Memory:"& $MEM[1] &" Excessive Memory Use - Restart Requested by 7dServerUtility Script")
	  ;ProcessClose($PID)
	  CloseServer()
	  Sleep (10000)
   EndIf
EndIf
       
If @HOUR = $HotHour And @MIN = $HotMin And $RestartDaily = "yes" Then 
   Local $PID = ProcessExists("7DaysToDie.exe")
	  If $PID Then
		 Local $MEM = ProcessGetStats($PID, 0)
		 FileWriteLine(@ScriptDir & "\7dServerUtility_RestartLog.txt", @MON &"-"& @MDAY &"-"& @YEAR &" "& @HOUR &":"& @MIN &" --Work Memory:"& $MEM[0] & _
		 " --Peak Memory:"& $MEM[1] &" Daily Restart Requested by 7dServerUtility Script")
		 ;ProcessClose($PID)
		 CloseServer()
	  EndIf
   Sleep (10000)    
EndIf

Sleep (500)
WEnd
 